%octave script that plots output from plumeria fortran model

%*****************************************************************************
%THE FOLLOWING PARAMETERS NEED TO BE SET BEFORE RUNNING PLOTEMUP
% fprintf(1,'\n');
% fprintf(1,'Note: before using plotemup.m, you need to modify the first few\n');
% fprintf(1,'lines of the code to indicate the number and name(s) of the output file(s)\n');
% fprintf(1,'that will be read and plotted\n');
% fprintf(1,'Press <enter> to continue\n');
% pause;
n_outfiles = 1;                                      %number of files to read (<=2)
outputfile1 = 'MSH.txt';
file1label  = 'MSH';                             %name of file 2 for plot legend
outputfile2 = 'MSH_200MPa.txt';     %name & location of first file
file2label  = '200';                             %name of file 2 for plot legend
outputfile3 = 'MSH_180MPa.txt';     %name & location of first file
file3label  = '180';                             %name of file 2 for plot legend
outputfile4 = 'MSH_160MPa.txt';     %name & location of first file
file4label  = '160';                             %name of file 2 for plot legend

%******************************************************************************
%WRITE OUT INPUT VALUES
fprintf(1,'number of output files to read = %d\n',n_outfiles);
fprintf(1,'output file 1=%s\n',outputfile1);
if n_outfiles==2
   fprintf(1,'output file 2=%s\n',outputfile2);
end

%CLEAR THE OLD PLOT(S)
clear plot;
clear legend;

%% ******************************************************************************
%OPEN THE FIRST OUTPUT FILE
fprintf(1,'opening %s \n',outputfile1);
inputline=char(80);
fid=fopen(outputfile1);                          %open file

%Look for the title to the output table
while (length(inputline)<11) || ~strcmp(inputline(1:12),'OUTPUT TABLE') && ~feof(fid)
     inputline = fgetl(fid);  %read in a line, looking for the start of the table
end

%If we didn't reach the end of the file, start reading numbers
if ~feof(fid)
    inputline=fgetl(fid);     %read the first line of the table titles
    nlines = str2double(inputline(1:4));    %number of lines in output table
    numbers = NaN(8,nlines);            %Initialize numbers array
    for i=1:nlines
       inputline=fgetl(fid);                   %read the next line
    	numbers(:,i)=str2num(inputline);        %convert the line to numbers
    end
end
fclose(fid);

%Assign numbers to variables
inum    = numbers(1,:);
z       = numbers(2,:)./1000;
pres    = numbers(3,:);
dpdt    = numbers(4,:);
vfgas   = numbers(5,:);
u       = numbers(6,:);
log_eta = numbers(7,:);
time    = numbers(8,:);

%% ******************************************************************************
%OPEN THE SECOND OUTPUT FILE
if n_outfiles>=2
   fprintf(1,'opening %s\n',outputfile2);
   fid2=fopen(outputfile2);    %open file
   fopen(fid2);
   inputline=char(80);
   
    %Look for the title to the output table
    while (length(inputline)<11) || ~strcmp(inputline(1:12),'OUTPUT TABLE') && ~feof(fid)
         inputline = fgetl(fid);  %read in a line, looking for the start of the table
    end

    %Start reading numbers
    if ~feof(fid)
        inputline=fgetl(fid);     %read the first line of the table titles
        nlines2 = str2double(inputline(1:4));    %number of lines in output table
        numbers2 = NaN(8,nlines2);            %Initialize numbers array
        for i=1:nlines2
           inputline=fgetl(fid);                   %read the next line
            numbers2(:,i)=str2num(inputline);        %convert the line to numbers
        end
    end
    fclose(fid);

    %Assign numbers to variables
    inum2    = numbers2(1,:);
    z2       = numbers2(2,:)./1000;
    pres2    = numbers2(3,:);
    dpdt2    = numbers2(4,:);
    vfgas2   = numbers2(5,:);
    u2       = numbers2(6,:);
    log_eta2 = numbers2(7,:);
    time2    = numbers2(8,:);
end

%% ******************************************************************************
%OPEN THE THIRD OUTPUT FILE
if n_outfiles>=3
   fprintf(1,'opening %s\n',outputfile3);
   fid3=fopen(outputfile3);    %open file
   fopen(fid3);
   inputline=char(80);
   
    %Look for the title to the output table
    while (length(inputline)<11) || ~strcmp(inputline(1:12),'OUTPUT TABLE') && ~feof(fid)
         inputline = fgetl(fid);  %read in a line, looking for the start of the table
    end

    %Start reading numbers
    if ~feof(fid)
        inputline=fgetl(fid);     %read the first line of the table titles
        nlines3 = str2double(inputline(1:4));    %number of lines in output table
        numbers3 = NaN(8,nlines3);            %Initialize numbers array
        for i=1:nlines3
           inputline=fgetl(fid);                   %read the next line
            numbers3(:,i)=str2num(inputline);        %convert the line to numbers
        end
    end
    fclose(fid);

    %Assign numbers to variables
    inum3    = numbers3(1,:);
    z3       = numbers3(2,:)./1000;
    pres3    = numbers3(3,:);
    dpdt3    = numbers3(4,:);
    vfgas3   = numbers3(5,:);
    u3       = numbers3(6,:);
    log_eta3 = numbers3(7,:);
    time3    = numbers3(8,:);
end

%******************************************************************************
%OPEN THE FOURTH OUTPUT FILE
if n_outfiles>=4
   fprintf(1,'opening %s\n',outputfile4);
   fid4=fopen(outputfile4);    %open file
   fopen(fid4);
   inputline=char(80);

       %Look for the title to the output table
    while (length(inputline)<11) || ~strcmp(inputline(1:12),'OUTPUT TABLE') && ~feof(fid)
         inputline = fgetl(fid);  %read in a line, looking for the start of the table
    end

    %Start reading numbers
    if ~feof(fid)
        inputline=fgetl(fid);     %read the first line of the table titles
        nlines4 = str2double(inputline(1:4));    %number of lines in output table
        numbers4 = NaN(8,nlines4);            %Initialize numbers array
        for i=1:nlines4
           inputline=fgetl(fid);                   %read the next line
            numbers4(:,i)=str2num(inputline);        %convert the line to numbers
        end
    end
    fclose(fid);

    %Assign numbers to variables
    inum4    = numbers4(1,:);
    z4       = numbers4(2,:)./1000;
    pres4    = numbers4(3,:);
    dpdt4    = numbers4(4,:);
    vfgas4   = numbers4(5,:);
    u4       = numbers4(6,:);
    log_eta4 = numbers4(7,:);
    time4    = numbers4(8,:);
end

%% ******************************************************************************
%START PLOTTING
subplot(1,5,1)                                         %velocity
   plot(pres,z), hold on;
   if n_outfiles==1
      legend(file1label);
    elseif n_outfiles==2
      plot(pres2,z2,'r');
      legend(file1label,file2label)
    elseif n_outfiles==3
      plot(pres2,z2,'r');
      plot(pres3,z3,'k');
      legend(file1label,file2label,file3label)
    elseif n_outfiles==4
      plot(pres2,z2,'r');
      plot(pres3,z3,'k');
      plot(pres4,z4,'m');
      legend(file1label,file2label,file3label,file4label)
   end
   xlabel('p, MPa');
   ylabel('depth, km');
subplot(1,5,2)                                         %temperature
   plot(vfgas,z), hold on;
   if n_outfiles==2
      plot(vfgas2,z2,'r');
    elseif n_outfiles==3
      plot(vfgas2,z2,'r');
      plot(vfgas3,z3,'k');
    elseif n_outfiles==4
      plot(vfgas2,z2,'r');
      plot(vfgas3,z3,'k');
      plot(vfgas4,z4,'m');
   end
   xlabel('vfgas');
   %set(gca,'XTick',[200:400:1200],'YTickLabel',[]);
   set(gca,'YTickLabel',[]);
subplot(1,5,3)                                         %radius
   plot(u,z), hold on;
   if n_outfiles==2
      plot(u2,z2,'r');
    elseif n_outfiles==3
      plot(u2,z2,'r');
      plot(u3,z3,'k');
    elseif n_outfiles==4
      plot(u2,z2,'r');
      plot(u3,z3,'k');
      plot(u4,z4,'m');
   end
   xlabel('u, m/s')
   set(gca,'YTickLabel',[]);
subplot(1,5,4)                                         %density
   semilogx(-dpdt,z), hold on;
   if n_outfiles==2
      semilogx(-dpdt2,z2,'r');
    elseif n_outfiles==3
      semilogx(-dpdt2,z2,'r');
      semilogx(-dpdt3,z3,'k');
    elseif n_outfiles==4
      semilogx(-dpdt2,z2,'r');
      semilogx(-dpdt3,z3,'k');
      semilogx(-dpdt4,z4,'m');
   end
   xlabel('-dpdt, MPa/s');
   set(gca,'YTickLabel',[]);
   grid on;
subplot(1,5,5)                                        %time
   plot(log_eta,z), hold on;
   if n_outfiles==2
      plot(log_eta2,z2,'r');
    elseif n_outfiles==3
      plot(log_eta2,z2,'r');
      plot(log_eta3,z3,'k');
    elseif n_outfiles==4
      plot(log_eta2,z2,'r');
      plot(log_eta3,z3,'k');
      plot(log_eta4,z4,'m');
   end
   xlabel('log10(visc), Pa s');
   %set(gca,'XTick',[0:1:5],'YTickLabel',[]);
   set(gca,'YTickLabel',[]);

