!##############################################################################
      module precis_param
        ! This precision parameter can be changed to meet your needs
      integer, parameter :: ip        = 8 ! Internal precision

      end module precis_param


!##############################################################################

      module Common1

      use precis_param

      real (kind=ip), dimension(10000) :: area,mach,pres,re, &
                       rho,time,vel,vesic,visc,z

      end module Common1

!##############################################################################

      module Common2
      use precis_param

      real (kind=ip)   :: beta,bubnum,Ca,cp,cv, &
             dadz,dfinal,dfirst,dhdp,diam,dpdz,dvdz,dz, &
             emax,eps,eta,etagas,etamag, &
             exmol,f,fo,g,gamma,h,hf,m,mdot,mg,mh2o,mm, &
             msil,mw,mxtls,pfinal,r,rey,rhof,rhomix, &
             rhoxtls,s, &
             sv,temp,v,vex,vfgas,vm,vxtls,xsarea,xtls,zfinal

      end module Common2


!##############################################################################

      module Common3
      use precis_param

      real (kind=ip)   :: Al2O3,CaO,Fe2O3,FeO,K2O,MgO, &
             Na2O,SiO2,TiO2

      end module Common3

!##############################################################################

      module outdata
      use precis_param

      real (kind=ip)  :: output(27,10000)

      end module outdata

!##############################################################################

      module ints

      integer   :: i,icalc,iend,ifinal,ifrag,im,ipp,io, &
             iruns,itherm,ives

      end module ints

!##############################################################################

      module water
      use precis_param

      real (kind=ip)   :: cpH2O,cvH2O,gH2O,hH2O,sH2O,vH2O,blkgas

      end module water

!##############################################################################

      module melt
      use precis_param

      real (kind=ip)  :: blkmag,cpm,dh2o,enthalpy,entropy,mwttot,rhom
      real (kind=ip)  :: wtoxan(9)

      end module melt

!##############################################################################

      module adjust_vars

      use precis_param

      real(kind=ip)  ::  v1m(100),v1o(100), v1p(100),zlm(100),zlp(100)
      real(kind=ip)  :: crit,gamma1,int1,slope,rmax0,rminv,vellast

      end module adjust_vars


