       subroutine checker(icalctxt,pres1,pfinal,ivt,vel1,t1,itemp, &
                cxtls,h2o,s,beta,ives,vex,z1,zfinal,dfirst, &
                dfinal,g,wtoxan,xtls,rhoxtls)

        use precis_param

        implicit none
        character icalctxt*4, answer*1
        real(kind=ip) ::  beta,cxtls,dfinal,dfirst,g,h2o,pres1, &
                         pfinal,rhoxtls,s,t1,totox,vel1, &
                         vex,xtls,z1,zfinal
        real(kind=ip) :: wtoxan(9)
        real(kind=ip) :: Al2O3,CaO,Fe2O3,FeO,K2O,MgO, &
             Na2O,SiO2,TiO2

        integer iox,ivt,itemp,ives

!       SUBROUTINE THAT CHECKS INPUT VALUES TO MAKE SURE THEY'RE 
!       REASONABLE

!       CHECK VALUE OF ICALCTXT
        if ((icalctxt.ne.'diam').and.(icalctxt.ne.'pgrd')) then
              write (6,5631) icalctxt
5631          format(5x,'On the third line of the input file, ',/, &
                'you entered "',a4,'"',/, &
                'You must enter  one of the following:',/, &
                '"pgrd", or "diam"')
                 stop
        end if

!     CHECK PRESSURE ENTRIES
        if (pfinal.gt.pres1) then
          write (6,1827)
1827        format (/,5x,'final pressure must be less than ', &
                     'initial pressure.  program stopped.')
            stop
        end if

!      MAKE SURE THAT DEPTHS ARE ENTERED CORRECTLY
        if (z1.gt.zfinal) then 
          write (6,1828) zfinal, z1
1828        format (/,5x,'Final depth must be less than ', &
                  'initial depth.  final depth =',e12.4,/, &
                  5x,'initial depth = ',e12.4,/, &
                    5x,'program stopped.')
            stop
        end if
        if ((z1.gt.0.).or.(zfinal.gt.0.)) then
          write (6,1829)
1829      format (/,5x,'One of your depths is less than zero.', &
                     '  Please enter positive values only.')
                 stop
        end if

!       QUERY USER IF CRYSTALLINITY IS >30%
        if (xtls.gt.59.) then
          write (6,9328) xtls
9328      format (/,5x,' You entered a crystallinity of ',f6.2,'%.',/, &
                 5x,'This program cannot handle', &
                    ' crystallinities above 59%.  Program stopped.')
          stop
        end if

        if (xtls.gt.30.) then
          write (6,9318) xtls
9318      format (/,5x,'You entered a crystallinity of ',f6.2,'%.',/, &
                  5x,'At crystallinities about about 30%,',/, &
                  5x,'the rheological law used in this model', &
                     ' becomes inaccurate.',/, &
                    5x,'Do you wish to continue? (y/n):'$)
        read(5,585) answer
        if (answer.ne.'y') then
            write (6,*) 'program stopped'
            stop
        end if
      end if

!      MAKE SURE WT% OXIDES ADD UP TO 100%.  QUERY THE USER IF THEY 
!      DON'T

        totox = 0.

        do iox=1,9
           totox = totox+wtoxan(iox)
        end do

        if (abs(totox-100.).gt.0.1) then
          write (6,584)
584       format (5x,'total of component oxides does not equal 100%.', &
                     '  Adjust automatically? (y/n)'$)
          read (5,585) answer
585       format (a1)
          if (answer.ne.'y') stop

          SiO2 = SiO2*(100./totox)
          Al2O3 = Al2O3*(100./totox)
          Fe2O3 = Fe2O3*(100./totox)
          FeO = FeO*(100./totox)
          MgO = MgO*(100./totox)
          CaO = CaO*(100./totox)
          TiO2 = TiO2*(100./totox)
          Na2O = Na2O*(100./totox)
          K2O = K2O*(100./totox)
        end if

        return
        end
