      SUBROUTINE gser(gamser,a,x,gln)

      use precis_param

      !Taken from Numerical Recipes for f77, by Press et al.  This subroutine
      !returns the incomplete gamma function p(o,z) evaluated by its series
      !representation as gauser.  It also returns ln(T(o)) as GLN

      INTEGER ITMAX
      real(kind=ip) :: a,gamser,gln,x,EPS
      PARAMETER (ITMAX=100,EPS=3.e-7)
!U    USES gammln
      INTEGER n
      real(kind=ip) :: ap,del,sum,gammln
      gln=gammln(a)
      if(x.le.0.)then
        if(x.lt.0.) then
            write (6,*) 'x < 0 in gser'
            stop
        end if
        gamser=0.
        return
      endif
      ap=a
      sum=1./a
      del=sum
      do 11 n=1,ITMAX
        ap=ap+1.
        del=del*x/ap
        sum=sum+del
        if(abs(del).lt.abs(sum)*EPS)goto 1
11    continue
      write (6,*) 'a too large, ITMAX too small in gser'
1     gamser=sum*exp(-x+a*log(x)-gln)
      return
      END
