      SUBROUTINE mmid(y,dydx,nvar,xs,htot,nstep,yout,derivs)

      use precis_param

      !modified from "Numerical Recipes for f77", by Press et al.
      !Modified midpoint step.  Dependent variable vectory y of length nvar and 
      !its derivative vector dydx are input at xs.  Also input is htot, the
      !total step to be made, and nstep, the number of substeps to be used.
      !The output is returned as yout, which need not be a distinct array
      !from y; if it is distinct, however, then y and dydx are returned undamaged.

      implicit none
      INTEGER nstep,nvar,NMAX
      real(kind=ip)  ::  htot,xs,dydx(nvar),y(nvar),yout(nvar)
      EXTERNAL derivs
      PARAMETER (NMAX=50)
      INTEGER i,n
      real(kind=ip)  ::  h,h2,swap,x,ym(NMAX),yn(NMAX)
      h=htot/nstep
      do 11 i=1,nvar
        ym(i)=y(i)
        yn(i)=y(i)+h*dydx(i)
11    continue
      x=xs+h
      call derivs(x,yn,yout)
      h2=2.*h
      do 13 n=2,nstep
        do 12 i=1,nvar
          swap=ym(i)+h2*yout(i)
          ym(i)=yn(i)
          yn(i)=swap
12      continue
        x=x+h
        call derivs(x,yn,yout)
13    continue
      do 14 i=1,nvar
        yout(i)=0.5*(ym(i)+yn(i)+h*yout(i))
14    continue
      return
      END
